#include <16f1947.h>
#device ADC=10
#include <string.h>
#include <stdlib.h>
#fuses INTRC_IO,NOWDT,NOLVP,PROTECT,NOBROWNOUT
//#fuses INTRC_IO,NOWDT,NOLVP,NOMCLR,PROTECT,NOBROWNOUT
#use delay(CLOCK=32MHz)
#use rs232(baud=19200,xmit=PIN_C6,rcv=PIN_C7,parity=N,bits=8,stream=c1,ERRORS)//
#use rs232(baud=19200,xmit=PIN_G1,rcv=PIN_G2,parity=N,bits=8,stream=c2,ERRORS)//
#use i2c(MASTER, SDA=PIN_C4, SCL=PIN_C3,SLOW,FORCE_HW)//FAST=400kbps SLOW=100kbps
//#include "rtc_rtc8564.c"
//#include "rtc_ds1307.c"
//#include "eeprom.c"
//#include "am2321.c"//xExZT[
//#include "aqmxx02a.c"//LN^LCDW[
//#include "so1602awxb.c"//L@ELLN^W[
//#include "tc74hc595.c"//o̓WbNIC

//ϐ蓖
//VA֌W
int get_command_value_c1 = 0;
int get_command_value_c2 = 0;
char get_command_c1[80] = {
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0};//MR}hɂ킹
char get_command_c2[10] = {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0};
char compare_command_c1[10] = {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0};
char compare_command_c2[10] = {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0};
char punctuate[] = ",";//VA̋̕؂
//tbJ[֌W
int flicker_hi = 0;
int flicker_hi_one = 0;
int flicker_low = 0;
long counttimer1 = 0;
long counttimer2 = 0;
long counttimer3 = 0;
long counttimer_servo = 0;
int counttimer_servo_one = 0;
int servo_angle = 0;
int life_index = 0;
char life_char[] = "/-_.";
long counttimer_lcd = 0;
int counttimer_lcd_one = 0;
//AiOv֌W
long analog_value = 0;
//fW^͊֌W
int port1_ra1 = 0;
int port1_ra4 = 0;
//̑
int servo = 0;

//֐錾
void startup();
void serial_process1();
void serial_process2();
void output_process();
void input_process();
void lcd_process();

//VÅ荞
#int_rda
void isr_rcv(){
	while(kbhit(c1)){  // }CR̎Mobt@̃f[^SĎM
		get_command_c1[get_command_value_c1] = fgetc(c1);//Mf[^o
		fprintf(c1,"%c",get_command_c1[get_command_value_c1]);
		get_command_value_c1++;//CfbNX{P
	}
}

#int_timer0
void int_timer(){
	//1msec

	//^C}[lZbg
	set_timer0(0x07);

	//AiOl擾
	analog_value = read_adc();
	set_adc_channel(1);

	if(counttimer1 > 99){
		//100msecPʂ̎s
		
		//JE^[Zbg
		counttimer1 = 0;
		
		flicker_hi = !flicker_hi;
		flicker_hi_one = 1;
	}
	counttimer1++;

	if(counttimer2 > 499){
		//500msecPʂ̎s
		
		//JE^[Zbg
		counttimer2 = 0;
		
		flicker_low = !flicker_low;

		//xExv
		//QɂP̊Ōv
		//am2321_read();
	}
	counttimer2++;
	counttimer3++;

	if(counttimer_lcd > 99){
		//100msecPʂ̎s
		
		//JE^[Zbg
		counttimer_lcd = 0;
		
		counttimer_lcd_one = 1;
	}
	counttimer_lcd++;

	if(counttimer_servo > 19){
		//20msecPʂ̎s
		
		//JE^[Zbg
		counttimer_servo = 0;
		
		counttimer_servo_one = 1;
	}
	counttimer_servo++;
	
}

//X^[gAbv
void startup(){
	
	//delay_ms(4000);

	//NbNݒ
	setup_oscillator(OSC_8MHZ|OSC_PLL_ON);

	setup_timer_0(RTCC_INTERNAL | RTCC_DIV_32 );
	enable_interrupts(INT_TIMER0); //^C}荞݋
	enable_interrupts(INT_RDA); //VA荞݋
	enable_interrupts(GLOBAL); //S荞݋

	//AiO|[g̐ݒ
	setup_vref(VREF_ON|VREF_ADC_4v096);
	setup_adc(ADC_CLOCK_INTERNAL);
	setup_adc_ports(sAN0,VSS_FVR);

	//|[gݒ 0:OUT 1:IN
	set_tris_a(0b00000011);//PORT1
	set_tris_b(0b00000000);
	set_tris_c(0b10011000);
	set_tris_d(0b00000000);//PORT1
	set_tris_e(0b00000000);//PORT2
	set_tris_f(0b00000000);//PORT2
	set_tris_g(0b00000100);

	//d肷̂҂
	delay_ms(200);

	//NbNAEgݒ(1b)
	//rtc_timer_1hz();

	//L@ELLN^W[̏
	//so1602awxb_init();

	//L@ELLN^W[\
	//Psڕ\
	//so1602awxb_cmd(0x80);
	//printf(so1602awxb_puts,"12345678901234567890");
	//sound_file_max
	//Qsڕ\
	//so1602awxb_cmd(0xa0);
	//printf(so1602awxb_puts,"abcdefghijklmnopqrst",);

	//LCD̏
	//RgXĝߎgpdw@3 = 3.3V 5 = 5V
	//delay܂܂Ă̂ŃX^[gAbvȊOŎgpȂ
	//aqmxx02a_init(5) ;

	//aqmxx02a_setcursor(0,0);        // \ʒuݒ肷
	//aqmxx02a_puts(")ްï");
	//aqmxx02a_puts("");
	//aqmxx02a_setcursor(0,1);        // \ʒuݒ肷
	//aqmxx02a_puts(" ZEATEC co.,ltd.");
}

//C
void main(){

	int tmp1 = 0;
		
	//X^[gAbv
	startup();
	while(true){

		//WbNICo
		//tc74hc595(counttimer3);

		//͏
		input_process();

		//VA|[g̃R}h
		serial_process1();
		serial_process2();

		//LCD̏(COɏ鎖)
		//if(counttimer_lcd_one != 0){
		//	counttimer_lcd_one = 0;

		//	lcd_process();
		//}

		
		if(counttimer_servo_one != 0){
			counttimer_servo_one = 0;

			servo_angle = analog_value * 0.176;
			output_bit(PIN_E0,1);
			delay_us(500);
			for(tmp1=0;tmp1<servo_angle;tmp1++){
				delay_us(9);delay_cycles(2);//10.5us
			}
			output_bit(PIN_E0,0);
		}

		//o͏
		output_process();	

		//if(flicker_hi_one != 0){
		//	//100mSecPʂŏ
		//	flicker_hi_one = 0;

		//	//Ct\p
		//	if(life_index == 3){
		//		life_index = 0;
		//	}else{
		//		life_index++;
		//	}
		//}
	}
}

void lcd_process(){
	//L@ELLN^W[\
	//Psڕ\
	//so1602awxb_cmd(0x80);
	//rtc_date_read();
	//printf(so1602awxb_puts,"ZEATEC 20%02x/%02x/%02x  %c",year,month,day,life_char[life_index]);
	////Qsڕ\
	//so1602awxb_cmd(0xa0);
	//if(week == 1){
	//	printf(so1602awxb_puts,"Sunday   ");//SUN
	//}else if(week == 2){
	//	printf(so1602awxb_puts,"Monday   ");//MON
	//}else if(week == 3){
	//	printf(so1602awxb_puts,"Tuesday  ");//TUE
	//}else if(week == 4){
	//	printf(so1602awxb_puts,"Wednesday");//WED
	//}else if(week == 5){
	//	printf(so1602awxb_puts,"Thursday ");//THU
	//}else if(week == 6){
	//	printf(so1602awxb_puts,"Friday   ");//FRI
	//}else if(week == 7){
	//	printf(so1602awxb_puts,"Saturday ");//SAT
	//}else{
	//	printf(so1602awxb_puts,"Error    ");//
	//}
	//printf(so1602awxb_puts,"   %02x:%02x:%02x",hour,min,sec);
}

//̓|[g擾
void input_process(){
	//if(input(PIN_A1)==1){
	//	//ON̎
	//	port1_ra1 = 1;
	//}else{
	//	//OFF̎
	//	port1_ra1 = 0;
	//}

	//port1_ra4 = input(PIN_A4);
}

//o̓|[g
void output_process(){

	//LED\(8)
	//LEDo͔͂]邱
	//output_bit(PIN_B0,!port1_ra4);
	output_bit(PIN_B0,!flicker_hi);
	output_bit(PIN_B1,!flicker_low);
	output_bit(PIN_B2,!flicker_hi);
	output_bit(PIN_B3,!flicker_low);
	output_bit(PIN_B4,!flicker_hi);
	output_bit(PIN_B5,!flicker_low);
	output_bit(PIN_C0,!flicker_hi);
	output_bit(PIN_C1,!flicker_low);

	//LED\(5)
	//LEDo͔͂]邱
	output_bit(PIN_C2,!flicker_hi);
	output_bit(PIN_C5,!flicker_low);
	output_bit(PIN_G0,!flicker_hi);
	output_bit(PIN_G3,!flicker_low);
	output_bit(PIN_G4,!flicker_hi);

	//PORT1
	//output_bit(PIN_A0,!flicker_hi);
	//output_bit(PIN_A1,!flicker_hi);
	output_bit(PIN_A2,!flicker_hi);
	output_bit(PIN_A3,!flicker_hi);
	output_bit(PIN_A4,!flicker_hi);
	output_bit(PIN_A5,!flicker_hi);
	output_bit(PIN_A6,!flicker_hi);
	output_bit(PIN_A7,!flicker_hi);

	if(flicker_hi==0){
		//PORT1
		output_d(0xff);
		//PORT2
		//output_e(0xff);
		output_f(0xff);
	}else{
		//PORT1
		output_d(0x00);
		//PORT2
		//output_e(0x00);
		output_f(0x00);
	}

}

//VA|[g̃R}h
void serial_process1(){
	int tmp1 = 0;
	char *command;
	int *param1;
	//char *param1;
	int rdata = 0;

	if(get_command_c1[get_command_value_c1-1]==0xd){
		//R}hƃp[^𕪊
		command = strtok(get_command_c1,punctuate);
		param1 = atoi(strtok(null,punctuate));
		//param1 = strtok(null,punctuate);

		fprintf(c1,"\r\n");

		strcpy(compare_command_c1,"?\r");
		if(strcmp(command,compare_command_c1)==0){
			//wv
			fprintf(c1,"ZT-****-SOFT Ver.0.90\r\n");
			fprintf(c1,"port1_ra0_analog(mV)=%ldmV\r\n",analog_value);
			fprintf(c1,"port1_ra1=%d\r\n",port1_ra1);
			
			//AhXԍPɃf[^
			//eeprom_write(0xa0,0x0001,0x06);
			//AhXԍPf[^ǂݍ
			//rdata = eeprom_read(0xa0, 0x0001);
			//fprintf(c1,"rdata=%x\r\n",rdata);

		}

		//strcpy(compare_command_c2,"time");
		//if(strcmp(command,compare_command_c2)==0){
		//	//Ԃݒ
		//	
		//	if(strlen(param1) == 13){
		//		//p[^𕪊ď
		//		//ݒFtime,160323101840(2016N0323101840b)
		//		//jwȂ
		//		year = ((param1[0] - 0x30)*16) + (param1[1] - 0x30);
		//		month = ((param1[2] - 0x30)*16) + (param1[3] - 0x30);
		//		day = ((param1[4] - 0x30)*16) + (param1[5] - 0x30);
		//		hour = ((param1[6] - 0x30)*16) + (param1[7] - 0x30);
		//		min = ((param1[8] - 0x30)*16) + (param1[9] - 0x30);
		//		sec = ((param1[10] - 0x30)*16) + (param1[11] - 0x30);

		//		rtc_date_set();
		//		fprintf(c1,"time set ok.\r\n");
		//	}else if(strlen(param1) == 14){
		//		//p[^𕪊ď
		//		//ݒFtime,1603234101840(2016N0323j101840b)
		//		//jw肠
		//		year = ((param1[0] - 0x30)*16) + (param1[1] - 0x30);
		//		month = ((param1[2] - 0x30)*16) + (param1[3] - 0x30);
		//		day = ((param1[4] - 0x30)*16) + (param1[5] - 0x30);
		//		week = param1[6];
		//		hour = ((param1[7] - 0x30)*16) + (param1[8] - 0x30);
		//		min = ((param1[9] - 0x30)*16) + (param1[10] - 0x30);
		//		sec = ((param1[11] - 0x30)*16) + (param1[12] - 0x30);

		//		rtc_date_set();
		//		fprintf(c1,"time set ok.\r\n");
		//	}else{
		//		fprintf(c1,"Parameter error.\r\n");
		//	}

		//}

		//strcpy(compare_command_c2,"time\r");
		//if(strcmp(command,compare_command_c2)==0){
		//	//ݎ\
		//	rtc_date_read();			
		//	fprintf(c1,"%02x/%02x/%02x ",year,month,day);
		//	if(week == 1){				fprintf(c1,"SUN");
		//	}else if(week == 2){		fprintf(c1,"MON");
		//	}else if(week == 3){		fprintf(c1,"TUE");
		//	}else if(week == 4){		fprintf(c1,"WED");
		//	}else if(week == 5){		fprintf(c1,"THU");
		//	}else if(week == 6){		fprintf(c1,"FRI");
		//	}else if(week == 7){		fprintf(c1,"SAT");
		//	}else{						fprintf(c1,"ERR");
		//	}
		//	fprintf(c1," %02x:%02x:%02x\r\n",hour,min,sec);
		//	//fprintf(c1,"%02x/%02x/%02x %02x:%02x:%02x\r\n",year,month,day,hour,min,sec);
		//}

		strcpy(compare_command_c1,"p");
		if(strcmp(command,compare_command_c1)==0){
			//p[^̎擾
			//up,1v1param1ɓ
			servo_angle = param1;
			fprintf(c1,"servo_angle=%u ok.\r\n",servo_angle);
		}

		//strcpy(compare_command_c1,"temp\r");
		//if(strcmp(command,compare_command_c1)==0){

		//	//xEx\
		//	fprintf(c1,"temperature = %ld.%ldC\r\n",(temperature-(temperature%10))/10,temperature%10);
		//	fprintf(c1,"humidity = %ld.%ld%%\r\n",(humidity-(humidity%10))/10,humidity%10);
		//}

		//SăNA
		for(tmp1=0;tmp1<80;++tmp1){
			get_command_c1[tmp1] = 0x0;
		}
		get_command_value_c1 = 0;

		//QƗp̃R}hNA
		for(tmp1=0;tmp1<10;++tmp1){
			compare_command_c1[tmp1] = 0x0;
		}
	}
}

void serial_process2(){
	int tmp1 = 0;
	char *command;
	int *param1;
	//char *param1;

	while(kbhit(c2)){  // }CR̎Mobt@̃f[^SĎM
		get_command_c2[get_command_value_c2] = fgetc(c2);//Mf[^o
		fprintf(c2,"%c",get_command_c2[get_command_value_c2]);
		get_command_value_c2++;
	}

	if(get_command_c2[get_command_value_c2-1]==0xd){
		//R}hƃp[^𕪊
		command = strtok(get_command_c2,punctuate);
		param1 = atoi(strtok(null,punctuate));
		//param1 = strtok(null,punctuate);

		fprintf(c2,"\r\n");

		strcpy(compare_command_c2,"?\r");
		if(strcmp(command,compare_command_c2)==0){
			//wv
			fprintf(c2,"ZT-****-SOFT Ver.0.90\r\n");
			//rtc_date_read();			
			//fprintf(c2,"%02x/%02x/%02x %02x:%02x:%02x\r\n",year,month,day,hour,min,sec);
		}

		strcpy(compare_command_c2,"p");
		if(strcmp(command,compare_command_c2)==0){
			//p[^̎擾
			//up,1v1param1ɓ
			servo_angle = param1;
			fprintf(c2,"servo_angle=%u ok.\r\n",servo_angle);
		}
		

		//strcpy(compare_command_c2,"time");
		//if(strcmp(command,compare_command_c2)==0){
		//	//Ԃݒ
		//	//ݒFtime,101006101840(2010N1006101840b)
		//	
		//	if(strlen(param1) == 13){
		//		//p[^𕪊
		//		year = ((param1[0] - 0x30)*16) + (param1[1] - 0x30);
		//		month = ((param1[2] - 0x30)*16) + (param1[3] - 0x30);
		//		day = ((param1[4] - 0x30)*16) + (param1[5] - 0x30);
		//		hour = ((param1[6] - 0x30)*16) + (param1[7] - 0x30);
		//		min = ((param1[8] - 0x30)*16) + (param1[9] - 0x30);
		//		sec = ((param1[10] - 0x30)*16) + (param1[11] - 0x30);

		//		rtc_date_set();
		//		fprintf(c2,"time set ok.\r\n");
		//	}else{
		//		fprintf(c2,"Parameter error.\r\n");
		//	}

		//}

		//strcpy(compare_command_c2,"time\r");
		//if(strcmp(command,compare_command_c2)==0){
		//	//ݎ\
		//	rtc_date_read();			
		//	fprintf(c2,"%02x/%02x/%02x %02x:%02x:%02x\r\n",year,month,day,hour,min,sec);
		//}

		//SăNA
		for(tmp1=0;tmp1<10;++tmp1){
			get_command_c2[tmp1] = 0x0;
		}
		get_command_value_c2 = 0;

		//QƗp̃R}hNA
		for(tmp1=0;tmp1<10;++tmp1){
			compare_command_c2[tmp1] = 0x0;
		}
	}
}


